#include <iostream>
#include <mpi.h>

using namespace std;

int main(int argc, char *argv[]) {

   // initialize MPI and get rank and size
   MPI_Init(&argc, &argv);
   
   int rank, size; 
   MPI_Comm_rank(MPI_COMM_WORLD, &rank);
   MPI_Comm_size(MPI_COMM_WORLD, &size);
   
   // check size == 2, otherwise abort with error code size
   if (size != 2) MPI_Abort(MPI_COMM_WORLD, size);
   
   // is this a dead-lock?
   int number = 42 + rank;
   int other  = 1 - rank;
   MPI_Send(&number, 1, MPI_INT, other, 0, MPI_COMM_WORLD);
   MPI_Recv(&number, 1, MPI_INT, other, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
   cout << "Rank " << rank << " received number " << number << endl; 

   // finalize MPI
   MPI_Finalize();

}
