#include <iostream>
#include <cstdlib>
#include <mpi.h>

using namespace std;

int main(int argc, char *argv[]) {

   // initialize MPI and get rank and size
   MPI_Init(&argc, &argv);
   
   int rank, size; 
   MPI_Comm_rank(MPI_COMM_WORLD, &rank);
   MPI_Comm_size(MPI_COMM_WORLD, &size);
   
   // check size == 2, otherwise abort with error code size
   if (size != 2) MPI_Abort(MPI_COMM_WORLD, size);
   
   

   // is this a dead-lock?
   int     n = atoi(argv[1]);          // size of array as cmd-line arg
   double *x = new double[n];
   double *y = new double[n];   

   cout << "Memory allocated on rank " << rank << endl;

   // fill some data
   x[0] = 42.0 + rank;

   // exchange data
   int other  = 1 - rank;
   MPI_Send(x, n, MPI_DOUBLE, other, 0, MPI_COMM_WORLD);
   MPI_Recv(y, n, MPI_DOUBLE, other, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
   cout << "Rank " << rank << " received number " << y[0] << endl; 

   // finalize MPI
   MPI_Finalize();

}
